Scrum - Defect #1583

Error when loading backlog: NoMethodError (undefined method ‘reset_positions_in_list' for
#<Issue:0x00007fab205fd390>):

2020-06-12 15:44 - Cyril Poulet

Status: Resolved

Priority: Normal

Category: Product backlog

Target version: Scrum v0.23.1

Source: Customer Blocked: No
Detected on version: Scrum v0.21.0 Alone: Yes
Description

from production.log :

Started GET "/projects/environnement-de-webconf-securise/product_backlog" for
XX . XX.XX.XX at 2020-06-12 15:16:10 +0200
Processing by ProductBacklogController#index as HTML

Parameters: {"project_id"=>"environnement-de-webconf-securise"}

Current user: aaaa.bbb (id=34)
Redirected to https://redmine.canton-consulting.com/product_backlog/26
Completed 302 Found in 26ms (ActiveRecord: 6.0ms)
Started GET "/product_backlog/26" for 82.66.49.25 at 2020-06-12 15:16:10 +0200
Processing by ProductBacklogController#show as HTML

Parameters: {"id"=>"26"}

Current user: aaaa.bbb (id=34)
Completed 500 Internal Server Error in 123ms (ActiveRecord: 9.3ms)

NoMethodError (undefined method "reset_positions_in_1list' for #<Issue:0x00007£fab205£d390>) :

plugins/scrum/app/controllers/product_backlog_controller.rb:208:in “check_issue_position'
plugins/scrum/app/controllers/product_backlog_controller.rb:214:in “block in check_issue_position'
plugins/scrum/app/controllers/product_backlog_controller.rb:213:in “~check_issue_position'
plugins/scrum/app/controllers/product_backlog_controller.rb:202:in "check_issue_positions'
lib/redmine/sudo_mode.rb:65:in " sudo_mode'

Installed Redmine :

Redmine version 4.1.1.stable

Ruby version 2.5.5-p157 (2019-03-15) [x86_64-linux-gnu]
Rails version 5.2.4.2

Environment production

Database adapter PostgreSQL

Mailer queue ActiveJob::QueueAdapters::AsyncAdapter
Mailer delivery smtp

(I am the one that created this issue on advanced_roadmap : https://redmine.ociotec.com/issues/1580)

Related issues:

Has duplicate Scrum - Defect #1610: Undefined method 'reset_positions_in_list... Rejected
Has duplicate Scrum - Defect #1603: Displaying backlog gives Internal error Rejected
Has duplicate Scrum - Defect #1600: Displaying backlog gives 500 error Rejected
History

#1 - 2020-07-19 17:16 - Cyril Poulet

Up

This makes the plugin not usable, as we cannot create spints until the backlog exists, and we cannot create the backlog.

#2 - 2020-07-21 08:02 - Emilio Gonzalez Montaina

Hi, | will take a look to the error... please disable the plugin setting to check PBIs sort on product backlog and let me know the results
https://redmine.ociotec.com/issues/1580

#3 - 2020-07-24 13:00 - Cyril Poulet

Hi

So as our use of redmine evolved, the problem evolved too.

| currently have a project with 8 subprojets, and the problem only occurs in one of the subprojet (not in the main project nor in the other subprojects).
It is still the same error with the same log signature.

| tried to check or uncheck the PBIs sort in the settings, but no changes.

#4 - 2020-08-25 22:49 - Kent Hulick

This comes when you assign an issue to the backlog that is not allowed to be in the backlog. It will also happen if you change the tracker to one that
is allowed at the same time as you assign it to the back log.

The best work around is to allow all issue types in the back log. That alone will not fix your backlog, and unfortunately the log message doesn't tell
you the ticket number that is breaking the backlog so there is no way to find it without manually querying the database. After you allow all issue types
in the back log take everything out of the backlog, make sure the backlog works, then assign them back into the backlog.

| created a custom query to find the issues breaking the backlog, but it doesn't always work if someone changes the tracker and assigns it to the
backlog at the same time. Getting the issue number in the log instead of the binary id number would be very useful.

As | type this the backlog for this project is similarly broken!!

#5 - 2020-09-24 10:42 - Travis Newman

I'm running into this problem as well:

Sep 24 18:39:32 pro-web-osticket docker[12372]: Completed 500 Internal Server Error in 12ms (

ActiveRecord: 4.5ms)

Sep 24 18:39:32 pro-web-osticket docker[12372]: NoMethodError (undefined method "reset_positions_in_list

' for #<Issue:0x00007£788bafl080>):

Sep 24 18:39:32 pro-web-osticket docker[12372]: plugins/scrum/app/controllers/product_backlog_controller.rb:20
8:1in “check_issue_position'

Sep 24 18:39:32 pro-web-osticket docker[12372]: plugins/scrum/app/controllers/product_backlog_controller.rb:21
4:in "block in check_issue_position'

Sep 24 18:39:32 pro-web-osticket docker[12372]: plugins/scrum/app/controllers/product_backlog_controller.rb:21
3:in ‘check_issue_position'

Sep 24 18:39:32 pro-web-osticket docker[12372]: plugins/scrum/app/controllers/product_backlog_controller.rb:20
2:in “check_issue_positions'

Sep 24 18:39:32 pro-web-osticket docker[12372]: lib/redmine/sudo_mode.rb:65:in " sudo_mode'

Disabling "PBls sort on product backlog" produced no noticeable effect.

#6 - 2020-09-30 10:23 - Vikram Lele
| am facing the same issue.
Some user accidentally assigned a task type issue to backlog, and after that accessing Backlog stopped working. Luckily workaround suggested by

Kent Hulick above worked (Thanks!). | searched for all non-user story issues that were assigned to backlog, and moved them to "none" sprint. This
got my backlog working again.

#7 - 2020-10-01 21:27 - Johan Dahl

| also got this issue then moving an issue (User story) with multiple tasks from Sprint to Backlog. The problem is that the tasks don't get assigned a
position. This is an issue (tracker 4 User Story) and two tasks (tracker 5). Then it is moved from a sprint to the backlog it will break it.

id tracker_id project_id subject parent_id root_id 1ft rgt sprint_id position
2577 4 20 Parent NULL 2577 1 8 4 0

2601 5 20 One task 2577 2577 2 3 4 NULL
2602 5 20 One more task 2577 2577 4 5 4 NULL

A solution | came up with which seems to fix this is to set position to the id of the parent

update issues set position = parent_id where position is null and sprint_id = 4 and tracker_id = 5 and parent_
id is not null

Of course you need to exchange the 4 for the id of your backlog and 5 to the id of your tracker containing tasks. Moving Simple PBl:s and Issues with
only one task don't create this problem.

#8 - 2020-10-02 07:21 - Johan Dahl
Update: | tried the suggestion above from Kent Hulik. | didn't crash the backlog and the item was sent to the backlog BUT the tasks remained on the

sprintboard but moved to the backlog column.

#9 - 2020-10-03 15:34 - Emilio Gonzalez Montaiha
- Alone changed from No to Yes
- Target version set to Scrum v0.22.0
- Status changed from New to In progress

- Category set to Product backlog

#10 - 2020-10-03 15:37 - Emilio Gonzalez Montaiia

- Status changed from In progress to Resolved

#11 - 2020-10-03 15:42 - Emilio Gonzalez Montaia
- Sprint set to Sprint 39

#12 - 2022-01-03 13:11 - Martin Meier

| had the same problem with 0.21.0 (the latest version | could find here).

The Johan Dahl solution solver my problem. What | noticed is that | had issues with two different trackers. One of the trackers was PBI ant the other
was Tasks. Probably someone moved tasks to the backlog sprint, but the tracker remained ant the past position was set to null. Giving a position to
the tasks solved my problem.

Emilio Gonzalez Montaia , is it fixed in 0.22.0? Where can | find this version?

Thanks.

#13 - 2022-04-20 08:06 - Vendel Czinder

Kent Hulick wrote in #note-4:

This comes when you assign an issue to the backlog that is not allowed to be in the backlog. It will also happen if you change the tracker to one
that is allowed at the same time as you assign it to the back log.

The best work around is to allow all issue types in the back log. That alone will not fix your backlog, and unfortunately the log message doesn't
tell you the ticket number that is breaking the backlog so there is no way to find it without manually querying the database. After you allow all
issue types in the back log take everything out of the backlog, make sure the backlog works, then assign them back into the backlog.

| created a custom query to find the issues breaking the backlog, but it doesn't always work if someone changes the tracker and assigns it to the
backlog at the same time. Getting the issue number in the log instead of the binary id number would be very useful.

As | type this the backlog for this project is similarly broken!!

We had the same problem, | can confirm that Kent Hulick's solution works!

#14 - 2023-01-23 12:52 - Emilio Gonzalez Montaiia

- Target version changed from Scrum v0.22.0 to Scrum v0.23.1

Added extra protection just in case...

#15 - 2023-01-23 13:03 - Emilio Gonzalez Montaiia

- Has duplicate Defect #1610: Undefined method ‘reset_positions_in_list' for Issue added

#16 - 2023-01-23 13:03 - Emilio Gonzalez Montafha
- Has duplicate Defect #1603: Displaying backlog gives Internal error added

#17 - 2023-01-23 13:04 - Emilio Gonzalez Montafha
- Has duplicate Defect #1600: Displaying backlog gives 500 error added
